/* Salinitiy Measuring
 *  Markus Opitz 2024
 *  instructables.com
 */

// OLED setup
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

// sensor setup
int sensorValue;   //you need to replace this value with Value_1
const int SensorPin = A0;
int salinity = 0;
 
 
void setup() {
  
  Serial.begin(115200); // open serial port, set the baud rate to 9600 bps
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3D)) { // Address 0x3C for 128x64
    Serial.println(F("SSD1306 allocation failed"));
    for(;;); // Don't proceed, loop forever
  }
    display.clearDisplay();
    display.display();
    display.setTextSize(2);
    display.setTextColor(WHITE);
        display.setCursor(0,0); display.println("start");
    display.display();
    delay(1000);
}
 
 
void loop() {
 getData();
 delay(1000);  //loop after 1 second
}  


void getData() {

  sensorValue = analogRead(SensorPin);
  salinity = map(sensorValue, 270, 380, 0, 35);  //270 is value for pure water, 380 for 35g/litre salt water

// output serial monitor
  Serial.println(sensorValue);
  Serial.print(salinity);Serial.println(" %");
  Serial.println("");
  delay(10);

// output OLED display
  display.clearDisplay();
  display.setTextColor(WHITE);
  display.setTextSize(2);
  display.setCursor(0, 0);
  display.println(sensorValue);
  display.drawLine(0, 18, 128, 18, WHITE);

  if (sensorValue > 244) {

    display.setCursor(0, 28);
    display.setTextSize(1);
    display.print("Salinity:  ");
    display.setTextSize(2);
    display.setCursor(40, 47);
    display.print(salinity); display.println(" g/l");
   }
  display.display();
}
